- Main Page
- Namespaces
- Classes
- Files
- Related Pages

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# Mers::Estimation::Discrete::Trajectories Class Reference

`#include <Trajectories.h>`

List of all members.

## Public Member Functions
| Trajectories (const double p, unsigned short db=0)
| Trajectories (Trajectories const &trajs)
| Trajectories (Trajectories const *trajs)
virtual | ~Trajectories ()
bool | addEstimate (Estimate *est)
const Estimate * | getMostLikelyEstimate () const
const Estimate * | getEstimate (const unsigned int index) const
Estimate * | getEstimateUnconst (const unsigned int index)
unsigned int | getNumberEstimates () const
double | getBeliefUncertainty () const
double | getAccumulatedUncertainty () const
bool | normalize ()
void | setDebug (const unsigned short db)
## Friends
std::ostream & | operator<< (std::ostream &, Trajectories const &)

## Detailed Description

The most likely trajectories are a set of estimates (listed in best-first order) which only focus on single, non-uniting, paths through the probability space. The amount of uncertainty at each time step is 1-Sum(Estimate Probabilities).

Definition at line 41 of file Trajectories.h.

## Constructor & Destructor Documentation

Trajectories::Trajectories | ( | const double | p,
|  | unsigned short | db = `0` |
| ) |  |  |

Creates new trajectories

Parameters:

  | p | the amount of uncertainty in the previous set of trajectories (initially 0.0)
  | db | the initial debug value (0 if unassigned)

Definition at line 31 of file Trajectories.cpp.

Trajectories::Trajectories | ( | Trajectories const & | trajs | ) |

Copy Constructor (shallow copy)

Parameters:

  | trajs | the Trajectories object to copy from

Definition at line 40 of file Trajectories.cpp.

Trajectories::Trajectories | ( | Trajectories const * | trajs | ) |

Copy Constructor (shallow copy)

Parameters:

  | trajs | the Trajectories object to copy from

Definition at line 45 of file Trajectories.cpp.

Trajectories::~Trajectories | ( |  | ) | `[virtual]`

Destroys all the trajectories

Definition at line 55 of file Trajectories.cpp.

## Member Function Documentation

bool Trajectories::addEstimate | ( | Estimate * | est | ) |

Adds and estimate to the set of trajectories

Parameters:

  | est | the estimate to be added

Returns:
  true if sucessfully added, false otherwise

Definition at line 74 of file Trajectories.cpp.

References Mers::Estimation::Discrete::Estimate::getProbability().

Referenced by Mers::Estimation::Discrete::ApproximateBeliefState::BFBSE::BFBSE::addEstimate(), Mers::Estimation::Discrete::ModeEstimatorBase::addEstimateToCurrentTrajectories(), Mers::Estimation::Discrete::ModeEstimation::ModeEstimator::generateTrajectories(), and Mers::Estimation::Discrete::CompiledME::CompiledModeEstimator::generateTrajectories().

Here is the call graph for this function:

const Estimate * Trajectories::getMostLikelyEstimate | ( |  | ) | const

Gets the most likely estimate off the front of the estimates vector

Returns:
  estimate, NULL if there are no estimates

Definition at line 117 of file Trajectories.cpp.

Referenced by Mers::Estimation::Discrete::ModeEstimatorBase::findModeEstimate(), Mers::Estimation::Discrete::ModeEstimationPerformance::ModeEstimatorDebug::findModeEstimate(), Mers::Estimation::Discrete::CompiledME::CompiledMEDebug::CBFTEDebug::findModeEstimate(), Mers::Estimation::Discrete::ModeEstimatorBase::findModeEstimateIntList(), and Mers::Estimation::Discrete::ModeEstimatorBase::progressToEstimate().

const Estimate * Trajectories::getEstimate | ( | const unsigned int | index | ) | const

Gets the specified estimate off the vector (0..N)

Parameters:

  | index | of the estimate to retrieve

Returns:
  estimate

Definition at line 126 of file Trajectories.cpp.

Referenced by Mers::Estimation::Discrete::Trigger::changeTrajectories(), Mers::Estimation::Discrete::ModeEstimation::ModeEstimator::generateTrajectories(), Mers::Estimation::Discrete::CompiledME::CompiledModeEstimator::generateTrajectories(), Mers::Estimation::Discrete::ApproximateBeliefState::BFBSE::BFBSE::generateTrajectories(), Mers::Estimation::Discrete::MEObjectiveFunction::getBeliefStateUncertainty(), Mers::Estimation::Discrete::ModeEstimationPerformance::MEPerformanceMonitor::getEstimateFaultTransitions(), and Mers::Estimation::Discrete::ModeEstimationPerformance::MEPerformanceMonitor::getPriorNextStateProbs().

Estimate * Trajectories::getEstimateUnconst | ( | const unsigned int | index | ) |

Gets the specified estimate off the vector (0..N)

Parameters:

  | index | of the estimate to retrieve

Returns:
  estimate

Definition at line 133 of file Trajectories.cpp.

unsigned int Trajectories::getNumberEstimates | ( |  | ) | const

Gets the number of estimates in the vector

Returns:
  number of estimates

Definition at line 141 of file Trajectories.cpp.

Referenced by Mers::Estimation::Discrete::Trigger::changeTrajectories(), Mers::Estimation::Discrete::ModeEstimation::ModeEstimator::generateTrajectories(), Mers::Estimation::Discrete::CompiledME::CompiledModeEstimator::generateTrajectories(), Mers::Estimation::Discrete::ApproximateBeliefState::BFBSE::BFBSE::generateTrajectories(), Mers::Estimation::Discrete::MEObjectiveFunction::getBeliefStateUncertainty(), Mers::Estimation::Discrete::ModeEstimationPerformance::MEPerformanceMonitor::getEstimateFaultTransitions(), Mers::Estimation::Discrete::ModeEstimationPerformance::MEPerformanceMonitor::getNumberFaultTransitions(), Mers::Estimation::Discrete::ModeEstimationPerformance::MEPerformanceMonitor::getPriorNextStateProbs(), Mers::Estimation::Discrete::Trigger::insertAssignment(), and normalize().

double Trajectories::getBeliefUncertainty | ( |  | ) | const

Gets this belief uncertainty (1-sum(estimate probabilities)). Returns this value regardless if the estimates have been normalized. This function has been DEPRECIATED

Returns:
  belief uncertainty

Definition at line 148 of file Trajectories.cpp.

Referenced by Mers::Estimation::Discrete::ModeEstimatorBase::addTrajectory(), and Mers::Estimation::Discrete::ModeEstimatorBase::getUncertainty().

double Trajectories::getAccumulatedUncertainty | ( |  | ) | const

Gets the accumulated uncertainty built up over time This function has been DEPRECIATED

Returns:
  uncertainty

Definition at line 155 of file Trajectories.cpp.

Referenced by Mers::Estimation::Discrete::ModeEstimation::ModeEstimator::generateTrajectories(), Mers::Estimation::Discrete::CompiledME::CompiledModeEstimator::generateTrajectories(), Mers::Estimation::Discrete::ApproximateBeliefState::BFBSE::BFBSE::generateTrajectories(), and Mers::Estimation::Discrete::operator<<().

bool Trajectories::normalize | ( |  | ) |

Normalizes the probabilities accross all estimates that these trajectories contain.

Definition at line 163 of file Trajectories.cpp.

References getNumberEstimates().

Referenced by Mers::Estimation::Discrete::ModeEstimatorBase::releaseMemoryAndNormalize().

Here is the call graph for this function:

void Trajectories::setDebug | ( | const unsigned short | db | ) |

Sets the debug flag to the value specified

Parameters:

  | db | the value to set the debug flag to (higher numbers are more output)

Definition at line 180 of file Trajectories.cpp.

Referenced by Mers::Estimation::Discrete::ModeEstimatorBase::setDebug().

The documentation for this class was generated from the following files:

- /Users/fpy/titan-1-5-MBARI/Mers/Estimation/Discrete/Trajectories.h
- /Users/fpy/titan-1-5-MBARI/Mers/Estimation/Discrete/Trajectories.cpp